## haskell-mode 17.2

=== Makefile ===
#
# Note: Due to MELPA distributing directly from github source version
# needs to be embedded in files as is without preprocessing.
#
# Version string is present in:
# - Makefile
# - haskell-mode.el
# - haskell-mode.texi
#
# We should have a script that changes it everywhere it is needed and
# syncs it with current git tag.
#
VERSION = 17.2-git

INSTALL_INFO = install-info

# Use $EMACS environment variable if present, so that all of these are
# equivalent:
#
# 1.  export EMACS=/path/to/emacs && make
# 2.  EMACS=/path/to/emacs make
# 3.  make EMACS=/path/to/emacs
#
# This is particularly useful when EMACS is set in ~/.bash_profile
#
EMACS ?= emacs
EMACS_VERSION := $(shell "$(EMACS)" -Q --batch --eval '(princ emacs-version)')

EFLAGS = --eval "(when (boundp 'load-prefer-newer) (setq load-prefer-newer t))"

BATCH = @echo EMACS $@; "$(EMACS)" $(EFLAGS) --batch -Q -L .

ELFILES := $(filter-out haskell-mode-autoloads.el haskell-mode-pkg.el,$(wildcard *.el))

ELCHECKS := $(wildcard tests/*-tests.el)

AUTOLOADS = haskell-mode-autoloads.el

PKG_DIST_FILES = $(ELFILES) logo.svg NEWS haskell-mode.info dir

INIT_PACKAGES="(progn \
  (require 'package) \
  (push '(\"melpa\" . \"https://melpa.org/packages/\") package-archives) \
  (package-initialize) \
  (dolist (pkg '(package-lint)) \
    (unless (package-installed-p pkg) \
      (unless (assoc pkg package-archive-contents) \
        (package-refresh-contents)) \
      (package-install pkg))) \
  )"


.PHONY: all compile info clean check check-emacs-version check-ert check-package-lint check-relint

all: check-emacs-version compile $(AUTOLOADS) info

check-emacs-version :
	$(BATCH) --eval "(when (version< emacs-version \"25.1\")				\
                            (message \"Error: haskell-mode requires Emacs 25.1 or later\")	\
                            (message \"Your version of Emacs is %s\" emacs-version)		\
                            (message \"Found as '$(EMACS)'\")					\
                            (message \"Use one of:\")						\
                            (message \"   1.  export EMACS=/path/to/emacs && make\")		\
                            (message \"   2.  EMACS=/path/to/emacs make\")			\
                            (message \"   3.  make EMACS=/path/to/emacs\")			\
                            (kill-emacs 2))"
	@echo Using EMACS = $(EMACS), version = $(EMACS_VERSION)

compile: build-$(EMACS_VERSION)/build-flag

build-$(EMACS_VERSION) :
	mkdir $@

# Emacs byte compilation state leaks from file to file if multiple
# files are requested to be build at the same time. We have to
# workaround this issue on Makefile level. Note also that we consider
# an .el file to be dependent on all other files because we do not do
# proper dependency tracking (yet).
build-$(EMACS_VERSION)/%.elc : %.el $(ELFILES)
	$(BATCH) --eval '(setq byte-compile-error-on-warn t)'						\
	         --eval "(setq byte-compile-dest-file-function (lambda (filename)					\
	               	       (concat (file-name-directory filename) \"build-\" emacs-version \"/\"	\
	                      	    (file-name-nondirectory filename) \"c\")))"				\
	         --eval "(when (check-declare-file \"$<\") (kill-emacs 2))" \
	         -f batch-byte-compile $<								\

build-$(EMACS_VERSION)/build-flag : build-$(EMACS_VERSION) $(patsubst %.el,build-$(EMACS_VERSION)/%.elc,$(ELFILES))
	touch $@

check-%: tests/%-tests.el
	$(BATCH) -l "$<" -f ert-run-tests-batch-and-exit;

check: compile $(AUTOLOADS) check-package-lint check-relint check-ert

check-ert: $(ELCHECKS)
	$(BATCH) -L tests									\
                 $(patsubst %,-l %,$(ELCHECKS))							\
                 -f ert-run-tests-batch-and-exit
	@echo "checks passed!"

# TODO: fix issues, then enforce build failure if this fails
check-package-lint:
	$(BATCH) --eval $(INIT_PACKAGES) --eval '(setq package-lint-main-file "haskell-mode-pkg.el")' -f package-lint-batch-and-exit $(ELFILES) || true

clean:
	$(RM) -r build-$(EMACS_VERSION) $(AUTOLOADS) $(AUTOLOADS:.el=.elc) haskell-mode.info dir

info: haskell-mode.info dir

dir: haskell-mode.info
	$(INSTALL_INFO) --dir=$@ $<

haskell-mode.info: doc/haskell-mode.texi
	LANG=en_US.UTF-8 $(MAKEINFO) $(MAKEINFO_FLAGS) -o $@ $<

doc/haskell-mode.html: doc/haskell-mode.texi doc/haskell-mode.css
	LANG=en_US.UTF-8 $(MAKEINFO) $(MAKEINFO_FLAGS) --html --css-include=doc/haskell-mode.css --no-split -o $@ $<
	$(BATCH) -l doc/haskell-manual-fixups.el -f haskell-manual-fixups-batch-and-exit $@

doc/html/index.html : doc/haskell-mode.texi
	if [ -e doc/html ]; then rm -r doc/html; fi
	mkdir doc/html
	cp -r doc/anim doc/html/anim
	LANG=en_US.UTF-8 $(MAKEINFO) $(MAKEINFO_FLAGS) --html				\
	    --css-ref=haskell-mode.css							\
	    -c AFTER_BODY_OPEN='<div class="background"> </div>'			\
	    -c EXTRA_HEAD='<link rel="shortcut icon" href="haskell-mode-32x32.png">'	\
	    -c SHOW_TITLE=0								\
	    -o doc/html $<
	$(BATCH) -l doc/haskell-manual-fixups.el -f haskell-manual-fixups-batch-and-exit doc/html/*.html

doc/html/haskell-mode.css : doc/haskell-mode.css doc/html/index.html
	cp $< $@

doc/html/haskell-mode.svg : images/haskell-mode.svg doc/html/index.html
	cp $< $@

doc/html/haskell-mode-32x32.png : images/haskell-mode-32x32.png doc/html/index.html
	cp $< $@

doc/html : doc/html/index.html			\
           doc/html/haskell-mode.css		\
           doc/html/haskell-mode.svg		\
           doc/html/haskell-mode-32x32.png

deploy-manual : doc/html
	cd doc && ./deploy-manual.sh

$(AUTOLOADS): $(ELFILES)
	$(BATCH) \
		--eval '(setq make-backup-files nil)' \
		--eval "(setq generated-autoload-file (concat command-line-default-directory \"/\" \"$@\"))" \
		-f batch-update-autoloads "."
# check if autoloads will really load
	$(BATCH) -l "$@"

=== debian/changelog ===
haskell-mode (17.2-3) unstable; urgency=medium

  * source only upload

 -- Thomas Koch <thomas@koch.ro>  Sun, 15 Nov 2020 22:52:31 +0100

haskell-mode (17.2-2) unstable; urgency=medium

  * disable failing test, see #973132

 -- Thomas Koch <thomas@koch.ro>  Sun, 15 Nov 2020 22:25:34 +0100

haskell-mode (17.2-1) unstable; urgency=medium

  * new upstream release
  * fix autopkgtest

 -- Thomas Koch <thomas@koch.ro>  Tue, 13 Oct 2020 21:28:53 +0200

=== debian/control ===
Source: haskell-mode
Section: lisp
Priority: optional
Maintainer: Debian Emacsen Team <debian-emacsen@lists.debian.org>
Uploaders: Barak A. Pearlmutter <bap@debian.org>,
 Thomas Koch <thomas@koch.ro>
Rules-Requires-Root: no
Build-Depends:
    cabal-install,
    debhelper-compat (= 12),
    dh-elpa,
    ghc,
    haskell-stack,
    install-info,
    emacs | emacs25 | emacs24 | emacs-snapshot,
    texinfo
Standards-Version: 4.5.0
Homepage: https://github.com/haskell/haskell-mode
Vcs-Git: https://salsa.debian.org/emacsen-team/haskell-mode.git
Vcs-Browser: https://salsa.debian.org/emacsen-team/haskell-mode
Testsuite: autopkgtest-pkg-elpa

Package: elpa-haskell-mode
Architecture: all
Depends: emacs25 | emacs24 | emacs-snapshot | emacs, ${misc:Depends}
Suggests: stylish-haskell
Replaces: haskell-mode (<< 16.1-4)
Breaks: haskell-mode (<< 16.1-4), agda-mode (<< 2.3.2)
Recommends: ghc
Description: major mode for editing Haskell in Emacs
 A major mode for editing Haskell (the functional
 programming language) in Emacs.
 .
 Major features:
  - syntax highlighting (font lock),
  - automatic indentation,
  - on-the-fly documentation,
  - interaction with inferior ghci or hugs instance,
  - scans declarations and places them in a menu.

Package: haskell-mode
Architecture: all
Depends: elpa-haskell-mode, ${misc:Depends}
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/haskell-mode-$1\.tar\.gz/ \
  https://github.com/haskell/haskell-mode/tags .*/v?(\d\S*)\.tar\.gz

## haskell-mode 17.3

=== Makefile ===
--- 
+++ 
@@ -150,6 +150,7 @@
 	$(BATCH) \
 		--eval '(setq make-backup-files nil)' \
 		--eval "(setq generated-autoload-file (concat command-line-default-directory \"/\" \"$@\"))" \
+		--eval "(require 'autoload)" \
 		-f batch-update-autoloads "."
 # check if autoloads will really load
 	$(BATCH) -l "$@"

=== debian/changelog ===
haskell-mode (17.3-1) unstable; urgency=medium

  [ David Bremner ]
  * Clean up dependencies: remove emacs-snapshot (not in Debian), and
    replace "emacs" with ${elpa:Depends}.

  [ Barak A. Pearlmutter ]
  * New upstream release
  * Bump debhelper from old 12 to 13
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse
  * Fix day-of-week for changelog entry 1.44-3
  * Update standards version to 4.6.2, no changes needed
  * Modernise debian/watch uscan support file to version 4
  * Remove old UNRELEASED stanza due to debian/changelog merge error
  * Remove transitional package haskell-mode (closes: #1032751)
  * Install CONTRIBUTING.md into docs
  * Install upstream changelog where it belongs (lost in the ELPA transition)
  * Install the haskell logo under an appropriate name
  * Add patch to update some stray upstream version 17.2-git's to 17.3

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 02 Aug 2023 16:21:09 +0100

haskell-mode (17.2-5) unstable; urgency=medium

  * Team upload
  [ Nicholas D Steeves ]
  * Drop emacs24 and emacs25 from Build-Depends (packages do not exist
    in bullseye).

  [ David Bremner ]
  * Add git as build-dep. Bug fix: "Tests fail against Emacs 28.2", thanks
    to Sean Whitton (Closes: #1025812).

 -- David Bremner <bremner@debian.org>  Mon, 02 Jan 2023 07:38:18 -0400

## haskell-mode 17.4

=== debian/changelog ===
haskell-mode (17.4-2) unstable; urgency=medium

  * Track upstream development, which pushed a different fix

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 06 Aug 2023 15:53:25 +0100

haskell-mode (17.4-1) unstable; urgency=medium

  * Track upstream, who is also working on the Emacs 29.1 test failure issue
  * Remove patches appropriately
  * Patch typo
  * New upstream release
  * Patch to remove bad redefinition of string-trim-left in test suite (closes: #1042890)

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 06 Aug 2023 15:07:58 +0100

## haskell-mode 17.5

=== Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 # We should have a script that changes it everywhere it is needed and
 # syncs it with current git tag.
 #
-VERSION = 17.2-git
+VERSION = 17.5
 
 INSTALL_INFO = install-info
 
@@ -30,7 +30,7 @@
 
 BATCH = @echo EMACS $@; "$(EMACS)" $(EFLAGS) --batch -Q -L .
 
-ELFILES := $(filter-out haskell-mode-autoloads.el haskell-mode-pkg.el,$(wildcard *.el))
+ELFILES := $(filter-out haskell-mode-autoloads.el,$(wildcard *.el))
 
 ELCHECKS := $(wildcard tests/*-tests.el)
 
@@ -100,7 +100,7 @@
 
 # TODO: fix issues, then enforce build failure if this fails
 check-package-lint:
-	$(BATCH) --eval $(INIT_PACKAGES) --eval '(setq package-lint-main-file "haskell-mode-pkg.el")' -f package-lint-batch-and-exit $(ELFILES) || true
+	$(BATCH) --eval $(INIT_PACKAGES) --eval '(setq package-lint-main-file "haskell-mode.el")' -f package-lint-batch-and-exit $(ELFILES) || true
 
 clean:
 	$(RM) -r build-$(EMACS_VERSION) $(AUTOLOADS) $(AUTOLOADS:.el=.elc) haskell-mode.info dir

=== debian/changelog ===
haskell-mode (17.5-2) unstable; urgency=medium

  * Team upload.
  * Rebuild against dh-elpa 2.1.5.
    Upload pushed to dgit-repos but not salsa.
    See <https://lists.debian.org/debian-emacsen/2024/07/msg00077.html>.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 25 Jul 2024 22:08:07 +0900

haskell-mode (17.5-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 20 Nov 2023 21:34:08 +0000

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with elpa

override_dh_auto_build:
	make info

execute_after_dh_install:
	-(cd debian/elpa-haskell-mode/usr/share/icons/locolor/scalable\
	  && mv --verbose logo.svg haskell.svg)

override_dh_installchangelogs:
	dh_installchangelogs NEWS

=== debian/watch ===
version=4
https://github.com/haskell/haskell-mode/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
